// CustomResolution.cpp : implementation file
//

#include "stdafx.h"
#include "Resolution.h"
#include "ResolutionDlg.h"
#include "CustomResolution.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCustomResolution dialog


CCustomResolution::CCustomResolution(CWnd* pParent /*=NULL*/)
	: CDialog(CCustomResolution::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCustomResolution)
	m_Frequency = 0;
	m_Height = 0;
	m_Width = 0;
	m_Bits = 0;
	//}}AFX_DATA_INIT
}


void CCustomResolution::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCustomResolution)
	DDX_Text(pDX, IDC_FREQUENCY, m_Frequency);
	DDV_MinMaxInt(pDX, m_Frequency, 0, 300);
	DDX_Text(pDX, IDC_HEIGHT, m_Height);
	DDV_MinMaxInt(pDX, m_Height, 0, 5000);
	DDX_Text(pDX, IDC_WIDTH, m_Width);
	DDV_MinMaxInt(pDX, m_Width, 0, 5000);
	DDX_Text(pDX, IDC_BITS, m_Bits);
	DDV_MinMaxInt(pDX, m_Bits, 1, 32);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCustomResolution, CDialog)
	//{{AFX_MSG_MAP(CCustomResolution)
	ON_LBN_SELCHANGE(IDC_LIST, OnSelchangeList)
	ON_BN_CLICKED(IDC_UPDATE, OnUpdate)
	ON_BN_CLICKED(IDC_DELETE, OnDelete)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCustomResolution message handlers

BOOL CCustomResolution::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	CResolutionDlg* dlg=(CResolutionDlg*)AfxGetMainWnd();
	CListBox* list= (CListBox*)GetDlgItem(IDC_LIST);

	int i;
	for(i=0;i<(dlg->m_CustomCount);i++)
	{
		CString str;
		
		str.Format("%-4d x %-4d %-2d bits @ %-3d Herts",
				dlg->m_Modes[WM_MENU_CHOICE_LAST-WM_MENU_CHOICE-i-1].dmPelsWidth,
				dlg->m_Modes[WM_MENU_CHOICE_LAST-WM_MENU_CHOICE-i-1].dmPelsHeight,
				dlg->m_Modes[WM_MENU_CHOICE_LAST-WM_MENU_CHOICE-i-1].dmBitsPerPel,
				dlg->m_Modes[WM_MENU_CHOICE_LAST-WM_MENU_CHOICE-i-1].dmDisplayFrequency);

		list->AddString(str);

	}
	list->AddString("");
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCustomResolution::OnSelchangeList() 
{

	// TODO: Add your control notification handler code here
	int pos;
	CListBox* list= (CListBox*)GetDlgItem(IDC_LIST);
	pos=list->GetCurSel();
    int count=list->GetCount();
	CResolutionDlg* dlg=(CResolutionDlg*)AfxGetMainWnd();
	/*
	CString str;
	str.Format("%d",pos);
	AfxMessageBox(str);
	return;
	*/

	if(pos<count-1){
		
		m_Bits=dlg->m_Modes[WM_MENU_CHOICE_LAST-WM_MENU_CHOICE-pos-1].dmBitsPerPel;
		m_Width=dlg->m_Modes[WM_MENU_CHOICE_LAST-WM_MENU_CHOICE-pos-1].dmPelsWidth;
		m_Height=dlg->m_Modes[WM_MENU_CHOICE_LAST-WM_MENU_CHOICE-pos-1].dmPelsHeight;
		m_Frequency=dlg->m_Modes[WM_MENU_CHOICE_LAST-WM_MENU_CHOICE-pos-1].dmDisplayFrequency;
	}
	else
		m_Bits=m_Width=m_Height=m_Frequency=0;

	UpdateData(FALSE);

	
}

void CCustomResolution::OnUpdate() 
{
	// TODO: Add your control notification handler code here
	
	CString str;

	CListBox* list= (CListBox*)GetDlgItem(IDC_LIST);
	
	
	int count=list->GetCount();

	int pos=list->GetCurSel();
	if(pos==LB_ERR)
		pos=count-1;

	CResolutionDlg* dlg=(CResolutionDlg*)AfxGetMainWnd();
	
	
	
	if(UpdateData())
	{
	
		str.Format("%-4d x %-4d %-2d bits @ %-3d Herts",
				m_Width,m_Height,m_Bits,m_Frequency);
	
		list->DeleteString(pos);
		list->InsertString(pos,str);
		if(pos==(count-1)){

			
			list->InsertString(count,"");
							
		}

		dlg->m_Modes[WM_MENU_CHOICE_LAST-WM_MENU_CHOICE-pos-1].dmBitsPerPel=m_Bits;
		dlg->m_Modes[WM_MENU_CHOICE_LAST-WM_MENU_CHOICE-pos-1].dmPelsWidth=m_Width;
		dlg->m_Modes[WM_MENU_CHOICE_LAST-WM_MENU_CHOICE-pos-1].dmPelsHeight=m_Height;
		dlg->m_Modes[WM_MENU_CHOICE_LAST-WM_MENU_CHOICE-pos-1].dmDisplayFrequency=m_Frequency;

		
		dlg->m_CustomCount=list->GetCount()-1;
	}
}


void CCustomResolution::OnDelete() 
{
	// TODO: Add your control notification handler code here
	CListBox* list=(CListBox*)GetDlgItem(IDC_LIST);
	int pos=list->GetCurSel();
	CResolutionDlg* dlg=(CResolutionDlg*)AfxGetMainWnd();

	if((pos!=LB_ERR)&&(pos<list->GetCount()-1))
	{
		int i;
		for(i=0;i<dlg->m_CustomCount;i++)
		{
			dlg->m_Modes[WM_MENU_CHOICE_LAST-WM_MENU_CHOICE-i]=
				 dlg->m_Modes[WM_MENU_CHOICE_LAST-WM_MENU_CHOICE-i];
		}

		list->DeleteString(pos);
		dlg->m_CustomCount--;



	}

}
