// ResolutionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Resolution.h"
#include "ResolutionDlg.h"
#include "CustomResolution.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CResolutionDlg dialog

CResolutionDlg::CResolutionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CResolutionDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CResolutionDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_Custom=NULL;
	Create (IDD, pParent);
	
}

void CResolutionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CResolutionDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CResolutionDlg, CDialog)
	//{{AFX_MSG_MAP(CResolutionDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_MESSAGE(WM_TRAY_NOTIFICATION,OnTrayNotification)
	ON_COMMAND(WM_EXIT,OnExit)
	ON_COMMAND(WM_ABOUT,OnAbout)
	ON_COMMAND(WM_CUSTOM,OnCustom)
	ON_COMMAND(WM_HELP,OnHelp)
	ON_WM_ENDSESSION()
	ON_COMMAND_RANGE(WM_MENU_CHOICE,WM_MENU_CHOICE+200,OnMenuChoice)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CResolutionDlg message handlers

BOOL CResolutionDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	
	
	// TODO: Add extra initialization here
	
	int i, res=1;
	
	
	//get all supported resolutions
	for(i=0;(i<200)&&res;i++)
	{
		m_Modes[i].dmSize=sizeof(DEVMODE);
		m_Modes[i].dmDriverExtra=0;
		res=EnumDisplaySettings(NULL,i,&m_Modes[i]);
	}


	//correct the number of modes 
	//cause the last call to EnumD... failed
	m_ModeCount=i-1;
	//sort the modes
	Sort(m_ModeCount);

	//leave only modes at highest frequency
	//on each resolution and color depth
	int j=i=0;
	while(i<m_ModeCount)
	{
		if(m_Modes[i].dmBitsPerPel!=m_Modes[i+1].dmBitsPerPel)
		{
			m_Modes[j]=m_Modes[i];
			j++;
		}
		i++;
	
	}
	//update the number of modes
	m_ModeCount=j;


	//INITIALIZE ALL EMPTY STRUCTURES
	for(i=m_ModeCount+1;i<WM_MENU_CHOICE_LAST-WM_MENU_CHOICE;i++)
		m_Modes[i]=m_Modes[0];


	///read custom modes
	HKEY key;
	DWORD disposition;
	DWORD type;
	DWORD count;
	DWORD size;

	LONG result=
		RegCreateKeyEx(HKEY_CURRENT_USER,
			"Software\\akbaraka\\resolution\\",
			0,
			NULL,
			REG_OPTION_NON_VOLATILE,
			KEY_ALL_ACCESS,
			NULL,
			&key,
			&disposition);

	if((result==ERROR_SUCCESS)&&(disposition==REG_OPENED_EXISTING_KEY))
	{
		size=sizeof(count);

		result= RegQueryValueEx(key,
			"count",
			NULL,
			&type,
			(unsigned char*)&count,
			&size
			);
		
		if(result==ERROR_SUCCESS)
		{

			m_CustomCount=count;
			size=sizeof(DEVMODE)*count;
			result=RegQueryValueEx(key,
				"data",
				NULL,
				&type,
				(unsigned char*)&(m_Modes[WM_MENU_CHOICE_LAST-WM_MENU_CHOICE-count]),
				&size
				);
			
			

		}

		RegCloseKey(key);

	
	}
	else
		AfxMessageBox("Error Accessing the Registry");


	



	////////////////////////////
	//initialize the tray icon structure
	iconData.hWnd=m_hWnd;
	iconData.hIcon=m_hIcon;
	strcpy(iconData.szTip,"Screen Resolution");
	iconData.uID=ID_TRAY;
	iconData.uCallbackMessage=WM_TRAY_NOTIFICATION;
	iconData.cbSize=sizeof(iconData);

	iconData.uFlags=NIF_ICON|NIF_TIP|NIF_MESSAGE ;
	
	/////////////////////////////
	//Add the tray icon
	Shell_NotifyIcon(NIM_ADD,&iconData);


	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CResolutionDlg::OnSysCommand(UINT nID, LPARAM lParam)
{

	CDialog::OnSysCommand(nID, lParam);
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CResolutionDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CResolutionDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CResolutionDlg::OnTrayNotification(UINT nID,LPARAM lParam)
{
	
	POINT CurPos ;
	GetCursorPos (&CurPos);

	

	if((nID==ID_TRAY)&&(lParam==WM_LBUTTONDOWN))
	{
			
		MakeMenu();


		//display the menu
		SetForegroundWindow (); //to make the menu correctly disappear
		m_Menu.TrackPopupMenu(TPM_RIGHTALIGN|TPM_LEFTBUTTON   ,CurPos.x ,CurPos.y,this);
		PostMessage (WM_NULL, 0, 0); //to make the menu correctly disappear


		return;
	}

	if((nID==ID_TRAY)&&(lParam==WM_RBUTTONDOWN))
	{
		MakeRightMenu();
		//ShowWindow(SW_SHOW);
		//SetFocus();
		SetForegroundWindow (); //to make the menu correctly disappear
		m_RightMenu.TrackPopupMenu(TPM_RIGHTALIGN|TPM_LEFTBUTTON   ,CurPos.x ,CurPos.y,this);
		PostMessage (WM_NULL, 0, 0); //to make the menu correctly disappear
	}


}



void CResolutionDlg::Sort(int count)
{
//	qsort(m_Modes,count,sizeof(DEVMODE),compare2);
	qsort(m_Modes,count,sizeof(DEVMODE), compare);
	
}


void CResolutionDlg::OnMenuChoice(UINT param)
{
	if(param)
	{
	
		ChangeDisplaySettings(&m_Modes[param-WM_MENU_CHOICE],CDS_UPDATEREGISTRY);
		m_Menu.CheckMenuRadioItem(WM_MENU_CHOICE,WM_MENU_CHOICE_LAST,param,MF_BYCOMMAND);
	}
}

void CResolutionDlg::OnExit()
{
	///read custom modes
	HKEY key;
	DWORD disposition;

	DWORD count;
	DWORD size;

	LONG result=
		RegCreateKeyEx(HKEY_CURRENT_USER,
			"Software\\akbaraka\\resolution\\",
			0,
			NULL,
			REG_OPTION_NON_VOLATILE,
			KEY_ALL_ACCESS,
			NULL,
			&key,
			&disposition);

	if(result==ERROR_SUCCESS)
	{
		count=m_CustomCount;
		size=sizeof(count);

		result= RegSetValueEx(key,
			"count",
			NULL,
			REG_DWORD,
			(unsigned char*)&count,
			size
			);
		if(result==ERROR_SUCCESS)
		{

			count=m_CustomCount;
			size=sizeof(DEVMODE)*count;
			result=RegSetValueEx(key,
				"data",
				NULL,
				REG_BINARY,
				(unsigned char*)&(m_Modes[WM_MENU_CHOICE_LAST-WM_MENU_CHOICE-count]),
				size
				);
					

		}

		RegCloseKey(key);

	
	}

	
	Shell_NotifyIcon(NIM_DELETE,&iconData);
	DestroyWindow();
}

void CResolutionDlg::OnOK()
{
	ShowWindow(SW_HIDE);
}

void CResolutionDlg::OnAbout()
{
	ShowWindow(SW_SHOW);
}
void CResolutionDlg::PostNcDestroy() 
{
	// TODO: Add your specialized code here and/or call the base class
	delete this;
	//CDialog::PostNcDestroy();
}

void CResolutionDlg::OnCustom()
{
	if(!m_Custom)
	{
		CCustomResolution* dlg=new CCustomResolution();
		m_Custom=dlg;


		dlg->DoModal();
		m_Custom=NULL;
	}
	else
		m_Custom->SetFocus();
}

void CResolutionDlg::MakeMenu()
{
	//////////////////////////////////////
	BOOL res=TRUE;
	CString str;
	int i;
	//int numModes;


	if(m_Menu.m_hMenu)
		m_Menu.DestroyMenu();

	//initialize the resolutions menu
	m_Menu.CreatePopupMenu();
	
	
	//make a header on menu
	m_Menu.AppendMenu(MF_STRING,0,"Screen Resolution");
	m_Menu.AppendMenu(MF_SEPARATOR,0,"");


	//create the menu with the modes
	for(i=0;i<m_ModeCount;i++)
	{

		str.Format("%-4d x %-4d %-2d bits @ %-3d Herts",
				m_Modes[i].dmPelsWidth,m_Modes[i].dmPelsHeight,
				m_Modes[i].dmBitsPerPel,m_Modes[i].dmDisplayFrequency);
		m_Menu.AppendMenu(MF_STRING,WM_MENU_CHOICE + i,str);

		//insert separator between different resolutions.
		if((i<m_ModeCount-1)&&
			((m_Modes[i].dmPelsWidth!=m_Modes[i+1].dmPelsWidth)||
			 (m_Modes[i].dmPelsHeight!=m_Modes[i+1].dmPelsHeight))
			)
			m_Menu.AppendMenu(MF_SEPARATOR,0,"");
	}

	
	if(m_CustomCount>0)
	{
		m_Menu.AppendMenu(MF_SEPARATOR,0,"");
		for(i=0;i<m_CustomCount;i++)
		{
			str.Format("%-4d x %-4d %-2d bits @ %-3d Herts",
				m_Modes[WM_MENU_CHOICE_LAST-WM_MENU_CHOICE-i-1].dmPelsWidth,m_Modes[WM_MENU_CHOICE_LAST-WM_MENU_CHOICE-i-1].dmPelsHeight,
				m_Modes[WM_MENU_CHOICE_LAST-WM_MENU_CHOICE-i-1].dmBitsPerPel,m_Modes[WM_MENU_CHOICE_LAST-WM_MENU_CHOICE-i-1].dmDisplayFrequency);

			m_Menu.AppendMenu(MF_STRING,WM_MENU_CHOICE_LAST-i-1,str);
		}
	}


			//check the current resolution
		DEVMODE curMode;
	

		//check the current mode
		m_Menu.CheckMenuRadioItem(WM_MENU_CHOICE,WM_MENU_CHOICE_LAST,WM_MENU_CHOICE_LAST,MF_BYCOMMAND);

		EnumDisplaySettings(NULL,ENUM_CURRENT_SETTINGS,&curMode);
		for(i=0;i<WM_MENU_CHOICE_LAST-WM_MENU_CHOICE;i++)
		{
			if(
				(m_Modes[i].dmPelsWidth==curMode.dmPelsWidth)&&
				(m_Modes[i].dmPelsHeight==curMode.dmPelsHeight)&&
				(m_Modes[i].dmBitsPerPel==curMode.dmBitsPerPel)&&
				(m_Modes[i].dmDisplayFrequency==curMode.dmDisplayFrequency)
			)
			{	
				m_Menu.CheckMenuRadioItem(WM_MENU_CHOICE,WM_MENU_CHOICE_LAST,WM_MENU_CHOICE+i,MF_BYCOMMAND);
			}


		}
	

}

void CResolutionDlg::MakeRightMenu()
{	
	
	if(!m_RightMenu.m_hMenu)
	{
		
	//create right-click menu
	m_RightMenu.CreatePopupMenu();
	m_RightMenu.AppendMenu(MF_STRING,0,"Screen Resolution");
	m_RightMenu.AppendMenu(MF_SEPARATOR,0,"");

	m_RightMenu.AppendMenu(MF_STRING,WM_ABOUT,"About...");
	m_RightMenu.AppendMenu(MF_STRING,WM_HELP,"Help...");
	m_RightMenu.AppendMenu(MF_SEPARATOR,0,"");
	m_RightMenu.AppendMenu(MF_STRING,WM_CUSTOM,"Custom modes...");
	m_RightMenu.AppendMenu(MF_SEPARATOR,0,"");
	m_RightMenu.AppendMenu(MF_STRING,WM_EXIT,"Exit");
	}

}

void CResolutionDlg::OnHelp()
{
	::WinHelp(m_hWnd, "RESOLUTION.HLP", HELP_CONTENTS, 0L); 
}

void CResolutionDlg::OnEndSession(BOOL bEnding) 
{
	CDialog::OnEndSession(bEnding);
	
	// TODO: Add your message handler code here
		
	if(bEnding&&((CResolutionApp*)AfxGetApp())->m_restore)
		ChangeDisplaySettings(&(((CResolutionApp*)AfxGetApp())->m_oldMode),CDS_UPDATEREGISTRY);
}
